Index: /trunk/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComSlice.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComSlice.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -137,9 +137,19 @@
 #endif
 #if H_3D
+#if HHI_INTER_COMP_PRED_K0052
+, m_inCmpPredFlag                 ( false )
+#endif
+#if HHI_CAM_PARA_K0052
+, m_numViews                        ( 0    )
+#endif
 , m_depthToDisparityB             ( NULL )
 , m_depthToDisparityF             ( NULL )
 #endif
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+, m_bApplyDIS                     (false)
+#else
 #if H_3D_SINGLE_DEPTH
 , m_bApplySingleDepthMode         (false)
+#endif
 #endif
 #endif
@@ -181,4 +191,20 @@
   m_iDefaultRefViewIdx = -1;
   m_bDefaultRefViewIdxAvailableFlag = false;
+#if HHI_INTER_COMP_PRED_K0052
+  m_ivMvPredFlag           = false;
+  m_ivMvScalingFlag        = false;
+  m_ivResPredFlag          = false;  
+  m_depthRefinementFlag    = false;
+  m_viewSynthesisPredFlag  = false;
+  m_depthBasedBlkPartFlag  = false;
+  m_mpiFlag                = false;
+  m_intraContourFlag       = false;
+  m_intraSdcWedgeFlag      = false;
+  m_qtPredFlag             = false;
+  m_interSdcFlag           = false;
+  m_depthIntraSkipFlag     = false;
+  m_subPbSize              =  1 << 6;
+  m_mpiSubPbSize           =  1 << 6;
+#endif
 }
 
@@ -188,5 +214,9 @@
   m_puiSubstreamSizes = NULL;
 #if H_3D
+#if HHI_CAM_PARA_K0052   
+  for( UInt i = 0; i < m_numViews; i++ )
+#else
   for( UInt i = 0; i < getViewIndex(); i++ )
+#endif
   {
     if ( m_depthToDisparityB && m_depthToDisparityB[ i ] )
@@ -198,5 +228,5 @@
     {
       delete[] m_depthToDisparityF [ i ];
-  }
+    }
   }
 
@@ -575,4 +605,8 @@
   Int i;
 
+#if HHI_RES_PRED_K0052
+  m_pocsInCurrRPSs.clear();
+#endif
+
   for(i=0; i < m_pcRPS->getNumberOfNegativePictures(); i++)
   {
@@ -585,4 +619,7 @@
       NumPocStCurr0++;
       pcRefPic->setCheckLTMSBPresent(false);  
+#if HHI_RES_PRED_K0052
+      m_pocsInCurrRPSs.push_back( pcRefPic->getPOC() ); 
+#endif
     }
   }
@@ -598,4 +635,7 @@
       NumPocStCurr1++;
       pcRefPic->setCheckLTMSBPresent(false);  
+#if HHI_RES_PRED_K0052
+      m_pocsInCurrRPSs.push_back( pcRefPic->getPOC() ); 
+#endif
     }
   }
@@ -610,4 +650,7 @@
       RefPicSetLtCurr[NumPocLtCurr] = pcRefPic;
       NumPocLtCurr++;
+#if HHI_RES_PRED_K0052
+      m_pocsInCurrRPSs.push_back( pcRefPic->getPOC() ); 
+#endif
     }
     if(pcRefPic==NULL) 
@@ -619,4 +662,7 @@
 
   Int numPocInterCurr = NumPocStCurr0 + NumPocStCurr1 + NumPocLtCurr; 
+#if HHI_RES_PRED_K0052
+  assert( numPocInterCurr == (Int) m_pocsInCurrRPSs.size() ); 
+#endif
   numPocTotalCurr = numPocInterCurr + getNumActiveRefLayerPics( );
   assert( numPocTotalCurr == getNumRpsCurrTempList() );
@@ -791,4 +837,23 @@
 Void TComSlice::setCamparaSlice( Int** aaiScale, Int** aaiOffset )
 {  
+#if HHI_CAM_PARA_K0052
+  Int voiInVps      = m_pcVPS->getVoiInVps(getViewIndex() ); 
+  if( m_pcVPS->getNumCp( voiInVps ) > 0 )
+  {    
+    if( m_pcVPS->getCpInSliceSegmentHeaderFlag( voiInVps ) )
+    {
+      for( Int m = 0; m < m_pcVPS->getNumCp( voiInVps ); m++ )
+      {      
+        Int j      = m_pcVPS->getCpRefVoi( voiInVps, m );
+        Int jInVps = m_pcVPS->getVoiInVps( j ); 
+
+        setCpScale   ( jInVps , aaiScale [ jInVps   ][ voiInVps ]);
+        setCpInvScale( jInVps , aaiScale [ voiInVps ][ jInVps   ]);
+        setCpOff     ( jInVps , aaiOffset[ jInVps   ][ voiInVps ]);
+        setCpInvOff  ( jInVps , aaiOffset[ voiInVps ][ jInVps   ]);
+      }
+    }
+  } 
+#else
   if( m_pcVPS->hasCamParInSliceHeader( m_viewIndex ) )
   {    
@@ -801,4 +866,5 @@
     }
   } 
+#endif
 }
 #endif
@@ -1099,6 +1165,10 @@
   }
 #endif
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+  m_bApplyDIS = pSrc->m_bApplyDIS;
+#else
 #if H_3D_SINGLE_DEPTH
   m_bApplySingleDepthMode = pSrc->m_bApplySingleDepthMode;
+#endif
 #endif
 #if H_3D_IC
@@ -2147,7 +2217,8 @@
 {
   m_numViews = 1; 
-#if HHI_VIEW_ID_LIST_I5_J0107
+#if HHI_VIEW_ID_LIST_I5_J0107 || HHI_INTER_COMP_PRED_K0052
 #if H_3D
   AOF( m_viewOIdxList.size() == 0 ); 
+  
   m_viewOIdxList.push_back( 0 );        
 #endif
@@ -2170,5 +2241,5 @@
       {
         m_numViews++;
-#if HHI_VIEW_ID_LIST_I5_J0107
+#if HHI_VIEW_ID_LIST_I5_J0107  || HHI_INTER_COMP_PRED_K0052
 #if H_3D
         m_viewOIdxList.push_back( getViewOrderIdx( lId ) );        
@@ -2210,6 +2281,15 @@
   Int i = 0, j = 0;
 
+#if HHI_CAM_PARA_K0052
+  m_numCp    = new Int [ iNumViews ];
+  m_cpRefVoi = new Int*[ iNumViews ];
+  m_cpInSliceSegmentHeaderFlag = new Bool[ iNumViews ];
+
+  m_cpPresentFlag  = new Bool*[ iNumViews ]; 
+#else
   m_bCamParPresent = new Bool[ iNumViews ];
   m_bCamParInSliceHeader = new Bool[ iNumViews ];
+#endif
+  
 
   m_aaaiCodedScale = new Int**[ iNumViews ];
@@ -2217,8 +2297,24 @@
   for ( i = 0; i < iNumViews ; i++ )
   {
+#if HHI_CAM_PARA_K0052
+    m_cpInSliceSegmentHeaderFlag[i] = false;     
+#else
     m_bCamParPresent[i] = false; 
     m_bCamParInSliceHeader[i] = false; 
+#endif
+    
     m_aaaiCodedScale[i] = new Int*[ 2 ];
     m_aaaiCodedOffset[i] = new Int*[ 2 ];
+
+#if HHI_CAM_PARA_K0052
+    m_numCp   [i] = 0; 
+    m_cpRefVoi[i] = new Int[ iNumViews ];
+    m_cpPresentFlag[i] = new Bool[ iNumViews ]; 
+    for ( j = 0; j < iNumViews; j++)
+    {
+      m_cpRefVoi[i][j] = 0; 
+      m_cpPresentFlag[i][j] = false; 
+    }
+#endif
     for ( j = 0; j < 2; j++ )
     {
@@ -2239,4 +2335,5 @@
   Int i = 0, j = 0;
 
+#if !HHI_CAM_PARA_K0052
   if ( m_bCamParPresent != NULL )
   {
@@ -2247,4 +2344,35 @@
     delete [] m_bCamParInSliceHeader;
   }
+#else
+  if ( m_numCp != NULL )
+  {
+    delete [] m_numCp;
+  }
+
+  if ( m_cpRefVoi != NULL )
+  {
+    for ( i = 0; i < iNumViews ; i++ )
+    {
+      delete [] m_cpRefVoi[i];
+    }
+    delete[] m_cpRefVoi; 
+  }
+
+  if ( m_cpPresentFlag != NULL )
+  {
+    for ( i = 0; i < iNumViews ; i++ )
+    {
+      delete [] m_cpPresentFlag[i];
+    }
+    delete[] m_cpPresentFlag; 
+  }
+
+
+  if ( m_cpInSliceSegmentHeaderFlag != NULL )
+  {
+    delete [] m_cpInSliceSegmentHeaderFlag;
+  }
+#endif
+
 
   if ( m_aaaiCodedScale != NULL )
@@ -2276,6 +2404,6 @@
 
 
-Void
-  TComVPS::initCamParaVPS( UInt uiViewIndex, Bool bCamParPresent, UInt uiCamParPrecision, Bool bCamParSlice, Int** aaiScale, Int** aaiOffset )
+#if !HHI_CAM_PARA_K0052
+Void TComVPS::initCamParaVPS( UInt uiViewIndex, Bool bCamParPresent, UInt uiCamParPrecision, Bool bCamParSlice, Int** aaiScale, Int** aaiOffset )
 {
   AOT( uiViewIndex != 0 && !bCamParSlice && ( aaiScale == 0 || aaiOffset == 0 ) );  
@@ -2296,4 +2424,5 @@
   }
 }
+#endif
 
 #endif // H_3D
@@ -2730,5 +2859,7 @@
 #endif
 #if H_3D
+#if !HHI_CAM_PARA_K0052
 , m_bCamParInSliceHeader      (false)
+#endif
 #endif
 {
@@ -3754,7 +3885,24 @@
       {
         Int layerIdInNuh = getRefPicLayerId( i );
+#if HHI_RES_PRED_K0052
+        TComPic* picV = getIvPic( getIsDepth(), getVPS()->getViewIndex( layerIdInNuh ) );
+        assert( picV != NULL ); 
+        std::vector<Int> pocsInCurrRPSsPicV = picV->getSlice(0)->getPocsInCurrRPSs(); 
+        Bool refRpRefAvailFlag = false; 
+        for (Int idx = 0; idx < pocsInCurrRPSsPicV.size(); idx++)
+        {
+          if ( pocsInCurrRPSsPicV[idx] == prevPOC )
+          {
+            refRpRefAvailFlag = true; 
+            break; 
+          }
+        }
+
+        if (getFirstTRefIdx(eRefPicList) >= 0 && refRpRefAvailFlag )
+#else
         Int viewIdx = getVPS()->getViewId( layerIdInNuh );
         TComPic*pcPicPrev = ivPicLists->getPic(viewIdx, 0, prevPOC);
         if (getFirstTRefIdx(eRefPicList) >= 0 && pcPicPrev && pcPicPrev->getSlice( 0 )->isReferenced())
+#endif
         {
           m_arpRefPicAvailable[eRefPicList][layerIdInNuh] = true;
@@ -3929,5 +4077,5 @@
 #if H_3D_NBDV_REF
   setupLUT = setupLUT || getDepthRefinementFlag( );
-#endif 
+#endif  
 
 #if H_3D_IV_MERGE
@@ -3939,9 +4087,17 @@
     return; 
 
+#if HHI_CAM_PARA_K0052
+  m_numViews = getVPS()->getNumViews(); 
+#endif
   /// GT: Allocation should be moved to a better place later; 
   if ( m_depthToDisparityB == NULL )
   {
+#if HHI_CAM_PARA_K0052    
+    m_depthToDisparityB = new Int*[ m_numViews ];
+    for ( Int i = 0; i < getVPS()->getNumViews(); i++ )
+#else
     m_depthToDisparityB = new Int*[ getViewIndex() ];
     for ( Int i = 0; i < getViewIndex(); i++ )
+#endif
     {
       m_depthToDisparityB[ i ] = new Int[ Int(1 << g_bitDepthY) ]; 
@@ -3949,8 +4105,14 @@
   }
 
+  
   if ( m_depthToDisparityF == NULL )
   {
+#if HHI_CAM_PARA_K0052    
+    m_depthToDisparityF = new Int*[ m_numViews ];
+    for ( Int i = 0; i < m_numViews; i++ )
+#else
     m_depthToDisparityF= new Int*[ getViewIndex() ];
     for ( Int i = 0; i < getViewIndex(); i++ )
+#endif
     {
       m_depthToDisparityF[ i ] = new Int[ Int(1 << g_bitDepthY) ]; 
@@ -3963,5 +4125,37 @@
   TComVPS* vps = getVPS(); 
 
+#if HHI_CAM_PARA_K0052
+  Int log2Div = g_bitDepthY - 1 + vps->getCpPrecision();
+  Int voiInVps = vps->getVoiInVps( getViewIndex() ); 
+  Bool camParaSH = vps->getCpInSliceSegmentHeaderFlag( voiInVps );  
+
+  Int* codScale     = camParaSH ? m_aaiCodedScale [ 0 ] : vps->getCodedScale    ( voiInVps ); 
+  Int* codOffset    = camParaSH ? m_aaiCodedOffset[ 0 ] : vps->getCodedOffset   ( voiInVps ); 
+  Int* invCodScale  = camParaSH ? m_aaiCodedScale [ 1 ] : vps->getInvCodedScale ( voiInVps ); 
+  Int* invCodOffset = camParaSH ? m_aaiCodedOffset[ 1 ] : vps->getInvCodedOffset( voiInVps ); 
+
+
+  for (Int i = 0; i < voiInVps; i++)
+  {
+    Int iInVoi = vps->getVoiInVps( i ); 
+#if ENC_DEC_TRACE && H_MV_ENC_DEC_TRAC
+    if ( g_traceCameraParameters )
+    {
+      std::cout << std::endl << "Cp: " << codScale   [ iInVoi ] << " " <<    codOffset[ iInVoi ] << " "
+                << invCodScale[ iInVoi ] << " " << invCodOffset[ iInVoi ] << " " << log2Div; 
+    }
+#endif
+    for ( Int d = 0; d <= ( ( 1 << g_bitDepthY ) - 1 ); d++ )
+    {      
+      Int offset =    ( codOffset  [ iInVoi ] << g_bitDepthY ) + ( ( 1 << log2Div ) >> 1 );         
+      m_depthToDisparityB[ iInVoi ][ d ] = ( codScale [ iInVoi ] * d + offset ) >> log2Div; 
+
+      Int invOffset = ( invCodOffset[ iInVoi ] << g_bitDepthY ) + ( ( 1 << log2Div ) >> 1 );         
+      m_depthToDisparityF[ iInVoi ][ d ] = ( invCodScale[ iInVoi ] * d + invOffset ) >> log2Div; 
+    }
+  }
+#else
   Int log2Div = g_bitDepthY - 1 + vps->getCamParPrecision();
+
   Int viewIndex = getViewIndex();
 
@@ -3984,4 +4178,5 @@
     }
   }
+#endif
 }
 #endif
@@ -4023,9 +4218,9 @@
 
 #if H_3D
-
 Void TComSlice::init3dToolParameters()
 {
   Bool depthFlag = getIsDepth();
 
+#if !HHI_INTER_COMP_PRED_K0052
   Bool depthOfRefViewsAvailFlag = false; 
   Bool textOfCurViewAvailFlag = false; 
@@ -4072,4 +4267,5 @@
     }
   }
+
 
   Bool lidG0  = ( getLayerId() > 0 );
@@ -4088,9 +4284,40 @@
   m_intraSdcWedgeFlag      = sps3dExt->getIntraSdcWedgeFlag    ( depthFlag ) && lidG0                                     ;                          
   m_qtPredFlag             = sps3dExt->getQtPredFlag           ( depthFlag ) && lidG0           &&   textOfCurViewAvailFlag;
-  m_interSdcFlag           = sps3dExt->getInterSdcFlag         ( depthFlag ) && lidG0                                    ;                               
+  m_interSdcFlag           = sps3dExt->getInterSdcFlag         ( depthFlag ) && lidG0                                    ;  
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+  m_depthIntraSkipFlag     = sps3dExt->getDepthIntraSkipFlag   ( depthFlag ) && lidG0                                    ;                          
+#else
   m_intraSingleFlag        = sps3dExt->getIntraSingleFlag      ( depthFlag ) && lidG0                                    ;                          
+#endif
 
   m_subPbSize              = lidG0 ? ( 1 << ( sps3dExt->getLog2SubPbSizeMinus3   ( depthFlag ) + 3 ) ) : getSPS()->getMaxCUWidth();  
   m_mpiSubPbSize           = 1 << ( sps3dExt->getLog2MpiSubPbSizeMinus3( depthFlag ) + 3 );
+#else
+  Bool nRLLG0 =  ( getVPS()->getNumRefListLayers( getLayerId() ) > 0 );     
+
+  TComSps3dExtension* sps3dExt = getSPS()->getSps3dExtension();
+
+  m_ivMvPredFlag           = sps3dExt->getIvMvPredFlag         ( depthFlag ) && nRLLG0                       ;                             
+  m_ivMvScalingFlag        = sps3dExt->getIvMvScalingFlag      ( depthFlag )                                 ;                             
+  m_ivResPredFlag          = sps3dExt->getIvResPredFlag        ( depthFlag ) && nRLLG0                       ;                               
+#if HHI_CAM_PARA_K0052
+  m_depthRefinementFlag    = sps3dExt->getDepthRefinementFlag  ( depthFlag )           && getInCompPredFlag() && m_cpAvailableFlag;
+  m_viewSynthesisPredFlag  = sps3dExt->getViewSynthesisPredFlag( depthFlag ) && nRLLG0 && getInCompPredFlag() && m_cpAvailableFlag;
+#else
+  m_depthRefinementFlag    = sps3dExt->getDepthRefinementFlag  ( depthFlag )           && getInCompPredFlag();                            
+  m_viewSynthesisPredFlag  = sps3dExt->getViewSynthesisPredFlag( depthFlag ) && nRLLG0 && getInCompPredFlag();                            
+#endif
+  m_depthBasedBlkPartFlag  = sps3dExt->getDepthBasedBlkPartFlag( depthFlag )           && getInCompPredFlag();                          
+  m_mpiFlag                = sps3dExt->getMpiFlag              ( depthFlag )           && getInCompPredFlag();
+  m_intraContourFlag       = sps3dExt->getIntraContourFlag     ( depthFlag )           && getInCompPredFlag();
+  m_intraSdcWedgeFlag      = sps3dExt->getIntraSdcWedgeFlag    ( depthFlag )                                 ;                          
+  m_qtPredFlag             = sps3dExt->getQtPredFlag           ( depthFlag )           && getInCompPredFlag();
+  m_interSdcFlag           = sps3dExt->getInterSdcFlag         ( depthFlag )                                 ;  
+  m_depthIntraSkipFlag     = sps3dExt->getDepthIntraSkipFlag   ( depthFlag )                                 ;                          
+
+  m_subPbSize              =  1 << ( sps3dExt->getLog2SubPbSizeMinus3   ( depthFlag ) + 3 );  
+  m_mpiSubPbSize           =  1 << ( sps3dExt->getLog2MpiSubPbSizeMinus3( depthFlag ) + 3 );
+
+#endif
 
 #if H_3D_OUTPUT_ACTIVE_TOOLS
@@ -4098,6 +4325,12 @@
   std::cout << "DepthFlag:              :" << getIsDepth()             << std::endl;
   std::cout << "ViewOrderIdx:           :" << getViewIndex()           << std::endl;
+#if HHI_INTER_COMP_PRED_K0052
+  std::cout << "InterCmpPredAvailableFlag:" << getInCmpPredAvailFlag() << std::endl;
+  std::cout << "InterCompPredFlag       :"  << getInCompPredFlag()     << std::endl;
+  //std::cout << "TextOfCurViewAvailFlag  :" << textOfCurViewAvailFlag   << std::endl;
+#else
   std::cout << "DepthOfRefViewsAvailFlag:" << depthOfRefViewsAvailFlag << std::endl;
   std::cout << "TextOfCurViewAvailFlag  :" << textOfCurViewAvailFlag   << std::endl;
+#endif
   
   std::cout << "ivMvPredFlag            :" << m_ivMvPredFlag           << std::endl;
@@ -4112,5 +4345,9 @@
   std::cout << "qtPredFlag              :" << m_qtPredFlag             << std::endl;
   std::cout << "interSdcFlag            :" << m_interSdcFlag           << std::endl;
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+  std::cout << "depthIntraSkipFlag      :" << m_depthIntraSkipFlag     << std::endl;    
+#else
   std::cout << "intraSingleFlag         :" << m_intraSingleFlag        << std::endl;    
+#endif
   std::cout << "subPbSize               :" << m_subPbSize              << std::endl;
   std::cout << "mpiSubPbSize            :" << m_mpiSubPbSize           << std::endl;
